umsg.PoolString("Spin To")
AddCSLuaFile("autorun/client/roll.lua")
AddCSLuaFile("autorun/client/climb_helpmenu.lua")
AddCSLuaFile("autorun/client/climb_menu.lua")
resource.AddFile("sound/climbswep/rolls/roll_1.mp3") -- Using a wav that is 170 kb? No thanks, it has the same quality even if it's in MP3 format.
resource.AddFile("sound/climbswep/effects/heartbeat.wav")
resource.AddFile("sound/climbswep/effects/exhausted.mp3")
CreateConVar("cswep_snapsallowed", "1", {FCVAR_ARCHIVE | FCVAR_REPLICATED | FCVAR_NOTIFY})
CreateConVar("cswep_gradualaccel", "1", {FCVAR_ARCHIVE | FCVAR_REPLICATED | FCVAR_NOTIFY})
CreateConVar("cswep_gradualaccel_global", "1", {FCVAR_ARCHIVE | FCVAR_REPLICATED | FCVAR_NOTIFY})
ScriptType = 1

local function CSWEP_RollPlayerSpawn(ply)
	ply.HasDoneARoll = false
	ply.OverRideCrouch = false
	ply.OverRideSprint = false
	ply.Speed = 1
	ply.Acceleration = 1.15
	ply.CurMaxSpeed = 1
	ply.MaxSpeed = 380
	ply.MinSpeed = 90
	ply.CrawlSpeed = 100
	ply.WalkSpeed = 130
	ply.SwimSpeed = 170
	ply.ExhaustedSoundDelay = CurTime() + 0.1
	ply:SetNWInt("FATIG_AMOUNT", 100)
end

hook.Add("PlayerSpawn", "CSWEP_RollPlayerSpawn", CSWEP_RollPlayerSpawn)

local Roll = {
	Sound("physics/cardboard/cardboard_box_break1.wav"),
	Sound("climbswep/rolls/roll_1.mp3") }

function CSWEP_WeLand(ply)
	if ply:Alive() and ply:IsValid() then
		if ply:GetActiveWeapon():GetClass() == "climb_swep" or ply:GetActiveWeapon():GetClass() == "climb_swepnogrip" and ply:GetActiveWeapon():IsValid() then
			if ply:EyeAngles().p >= 35 then
				if ply:KeyDown(IN_RELOAD) and ply:KeyDown(IN_DUCK) and ply:GetVelocity().z <= -400 and ply:GetVelocity():Length() <= 1000 then
					ply.HasDoneARoll = true
					umsg.Start("Spin To", ply)
						umsg.Float(360)
						umsg.Float(1.8)
					umsg.End()
					ply:EmitSound(table.Random(Roll), 70, math.random(95, 105))
					ply:ConCommand("+duck")
					timer.Simple(0.5, function()
						if ply:IsValid() then
							ply:ConCommand("-duck")
							ply.HasDoneARoll = false
						end
					end)
					timer.Simple(1.2, function()
						if ply:IsValid() then
							ply:SetUnDuckSpeed(0.35)
						end
					end)
					ply.OverRideSpeed = true
				end
			end
		else
			if ply:EyeAngles().p >= 35 then
				if ply:KeyDown(IN_DUCK) and ply:GetVelocity().z <= -400 and ply:GetVelocity():Length() <= 1000 then
					if ply:GetActiveWeapon():IsValid() and ply:IsValid() then
						ply:DrawViewModel(false)
						ply:GetActiveWeapon():SetNextPrimaryFire(CurTime() + 0.6)
						ply:GetActiveWeapon():SetNextSecondaryFire(CurTime() + 0.6)
						timer.Simple(0.4, function()
							if ply:GetActiveWeapon():IsValid() and ply:IsValid() then
								ply:GetActiveWeapon():SendWeaponAnim(ACT_VM_DRAW)
								ply:GetActiveWeapon():SetNextPrimaryFire(CurTime() + ply:GetActiveWeapon():SequenceDuration())
								ply:GetActiveWeapon():SetNextSecondaryFire(CurTime() + ply:GetActiveWeapon():SequenceDuration())
								ply:DrawViewModel(true)
							end
						end)
					end
					ply.HasDoneARoll = true
					umsg.Start("Spin To", ply)
						umsg.Float(360)
						umsg.Float(1.8)
					umsg.End()
					ply:EmitSound(table.Random(Roll), 70, math.random(95, 105))
					ply:ConCommand("+duck")
					timer.Simple(0.5, function()
						if ply:IsValid() then
							ply:ConCommand("-duck")
							ply.HasDoneARoll = false
						end
					end)
					timer.Simple(1.2, function()
						if ply:IsValid() then
							ply:SetUnDuckSpeed(0.35)
						end
					end)
					ply.OverRideSpeed = true
				end
			end
		end
		ply.UsedTimes = 0
		ply.Hanging = false
		ply.HasWallJumped = false
		ply.CurMaxSpeed = ply.Speed / 2
		ply.Speed = ply.Speed / 2
	end
end

hook.Add("OnPlayerHitGround", "CSWEP_WeLand", CSWEP_WeLand)

local function CSWEP_DoARoll(ent, inflictor, attacker, amount, dmginfo)
	if ent:IsPlayer() then
		if ent.HasDoneARoll == true then
			Msg("Received damage: " .. math.Round(dmginfo:GetDamage()) .. "\nRoll decreased it to: " .. math.Round(dmginfo:GetDamage() * 0.5) .. "\n")
			if (ent:Health() - (dmginfo:GetDamage() * 0.5)) > 0 then
				if dmginfo:IsFallDamage() then
					dmginfo:ScaleDamage(0.5)
					ent:SetUnDuckSpeed(0.6) -- it's hard to stand up if our landing was painful
					ent.CurMaxSpeed = 150
					ent.Speed = 150
				end
			elseif ent:GetVelocity():Length() > 1000 then
				return
			end
		end
	end
end

hook.Add("EntityTakeDamage", "CSWEP_DoARoll", CSWEP_DoARoll)

local function CSWEP_PlayerDies(victim, inflictor, killer)
	victim:SetNWInt("FATIG_AMOUNT", 100)
	victim:SetNWInt("FATIG_TIRED", 0)
end

hook.Add("PlayerDeath", "CSWEP_PlayerDies", CSWEP_PlayerDies)

local function CSWEP_ConstantMovingWhileRolling()
	for k, ply in pairs(player.GetAll()) do
		if ply.HasDoneARoll == true then
			ply:SetLocalVelocity(ply:GetForward() * 150)
		end
	end
end

hook.Add("Tick", "CSWEP_ConstantMovingWhileRolling", CSWEP_ConstantMovingWhileRolling)

local function CSWEP_WeDie(ply)
	ply.HasDoneARoll = false
	ply:ConCommand("-duck")
end

hook.Add("PlayerDeath", "CSWEP_WeDie", CSWEP_WeDie)

local function CSWEP_DynamicFallDamage( ply, speed )
	if GetConVarNumber("mp_falldamage") == 1 then
		speed = speed - 480
		return speed * (100/(1024-450))
	end
end

hook.Add("GetFallDamage", "CSWEP_DynamicFallDamage", CSWEP_DynamicFallDamage)

concommand.Add("cswep_switchscripts", function(ply)
	if not ply:IsAdmin() then
		ply:ChatPrint("Admin-Only.")
		return
	end

	if ScriptType == 1 then
		ScriptType = 2
		hook.Remove("GetFallDamage", "CSWEP_DynamicFallDamage")
		hook.Remove("PlayerDeath", "CSWEP_WeDie")
		hook.Remove("Tick", "CSWEP_ConstantMovingWhileRolling")
		hook.Remove("EntityTakeDamage", "CSWEP_DoARoll")
		hook.Remove("OnPlayerHitGround", "CSWEP_WeLand")
		hook.Remove("PlayerSpawn", "CSWEP_RollPlayerSpawn")
		hook.Add("PlayerSpawn", "RollPlayerSpawn2", RollPlayerSpawn2)
		hook.Add("OnPlayerHitGround", "PlayerLandsRoll2", PlayerLandsRoll2)
		hook.Add("EntityTakeDamage", "DoARoll2", DoARoll2)
		hook.Add("Think","RollThink2", RollThink2)
		hook.Add("GetFallDamage","DynamicFallDamage2", DynamicFallDamage2)
		for k, v in pairs (player.GetAll()) do
			v:ChatPrint("ATTENTION! SCRIPT TYPE HAS BEEN CHANGED TO 2! SWITCH OVER TO ZOEY'S CLIMB SWEP OR OTHERWISE YOU WILL GET LOTS OF ERRORS!")
			v:SendLua( string.format( "GAMEMODE:AddNotify( %q, %s, %d )", "ATTENTION! SCRIPT TYPE HAS BEEN CHANGED TO 2! SWITCH OVER TO ZOEY'S CLIMB SWEP OR OTHERWISE YOU WILL GET LOTS OF ERRORS!", "NOTIFY_GENERIC", 5 ) )
			SendUserMessage("Switch Sound", v)
		end
	elseif ScriptType == 2 then
		ScriptType = 1
		hook.Remove("PlayerSpawn", "RollPlayerSpawn2")
		hook.Remove("OnPlayerHitGround", "PlayerLandsRoll2")
		hook.Remove("EntityTakeDamage", "DoARoll2")
		hook.Remove("Think","RollThink2")
		hook.Remove("GetFallDamage","DynamicFallDamage2")
		hook.Add("GetFallDamage", "CSWEP_DynamicFallDamage", CSWEP_DynamicFallDamage)
		hook.Add("PlayerSpawn", "CSWEP_RollPlayerSpawn", CSWEP_RollPlayerSpawn)
		hook.Add("PlayerDeath", "CSWEP_WeDie", CSWEP_WeDie)
		hook.Add("Tick", "CSWEP_ConstantMovingWhileRolling", CSWEP_ConstantMovingWhileRolling)
		hook.Add("EntityTakeDamage", "CSWEP_DoARoll", CSWEP_DoARoll)
		hook.Add("OnPlayerHitGround", "CSWEP_WeLand", CSWEP_WeLand)
		for k, v in pairs (player.GetAll()) do
			v:ChatPrint("ATTENTION! SCRIPT TYPE HAS BEEN CHANGED TO 1! SWITCH OVER TO SPY'S CLIMB SWEP OR OTHERWISE YOU WILL GET LOTS OF ERRORS!")
			v:SendLua( string.format( "GAMEMODE:AddNotify( %q, %s, %d )", "ATTENTION! SCRIPT TYPE HAS BEEN CHANGED TO 1! SWITCH OVER TO SPY'S CLIMB SWEP OR OTHERWISE YOU WILL GET LOTS OF ERRORS!", "NOTIFY_GENERIC", 5 ) )
			SendUserMessage("Switch Sound", v)
		end
	end
end)

local function CSWEP_UpdateSettings(ply)
	if not ply:IsAdmin() then
		ply:ChatPrint("Admin-only.")
		return
	end
	
	game.ConsoleCommand("cswep_snapsallowed " .. math.Clamp(tonumber(ply:GetInfo("cswep_snapsallowed_cl")), 0, 1) .. "\n")
	game.ConsoleCommand("cswep_gradualaccel " .. math.Clamp(tonumber(ply:GetInfo("cswep_gradualaccel_cl")), 0, 1) .. "\n")
	game.ConsoleCommand("cswep_gradualaccel_global " .. math.Clamp(tonumber(ply:GetInfo("cswep_gradualaccel_global_cl")), 0, 1) .. "\n") 
end

concommand.Add("cswep_updatesettings", CSWEP_UpdateSettings)

local function CSWEP_ResetSettings(ply)
	if not ply:IsAdmin() then
		ply:ChatPrint("Admin-only.")
		return
	end
	
	game.ConsoleCommand("cswep_snapsallowed 1\n")
	game.ConsoleCommand("cswep_gradualaccel 1\n")
	game.ConsoleCommand("cswep_gradualaccel_global 0\n")
	
	for k, v in pairs(player.GetAll()) do
		if v:IsAdmin() then
			v:ConCommand("cswep_snapsallowed_cl 1")
			v:ConCommand("cswep_gradualaccel_cl 1")
			v:ConCommand("cswep_gradualaccel_global_cl 0")
		end
	end
end

concommand.Add("cswep_resetsettings", CSWEP_ResetSettings)