local function CSWEP_SpeedBoostSprint(ply, key)
	if key == IN_SPEED then
		ply.OverRideSprint = true
	end
end

hook.Add("KeyPress", "CSWEP_SpeedBoostSprint", CSWEP_SpeedBoostSprint)

local function CSWEP_ReleaseSprint(ply, key)
	if key == IN_SPEED then
		ply.OverRideSprint = false
	end
end

hook.Add("KeyRelease", "CSWEP_ReleaseSprint", CSWEP_ReleaseSprint)

local PlayerMeta = FindMetaTable("Player")

function PlayerMeta:GetSpeed() -- Edited Gradual Acceleration written by GParkour guys
	if self:Alive() then
		if self:KeyDown(IN_FORWARD) and (self:KeyDown(IN_MOVELEFT) or self:KeyDown(IN_MOVERIGHT)) then
			self.CurMaxSpeed = self.MaxSpeed * 0.8
		elseif not self:KeyDown(IN_FORWARD) and not self:Crouching() and (self:KeyDown(IN_MOVELEFT) or self:KeyDown(IN_MOVERIGHT)) then
			self.CurMaxSpeed = self.MaxSpeed * 0.3
		else
			self.CurMaxSpeed = self.MaxSpeed
		end
		
		if self:KeyDown(IN_BACK) then
			self.CurMaxSpeed = self.MaxSpeed * 0.4
		end
		
		if self:KeyDown(IN_FORWARD) then
			if self.OverRideSprint == true and not self:Crouching() and not self:KeyDown(IN_WALK) and self:GetVelocity():Length() >= self.MinSpeed then
				self.Speed = self.Speed + (self.Acceleration + 1.5)
				self.CurMaxSpeed = self.MaxSpeed + 50
				
				if self:GetActiveWeapon():GetClass() == "climb_swep" or self:GetActiveWeapon():GetClass() == "climb_swep_anim" then
					self:SetNWInt("FATIG_AMOUNT", math.Clamp(self:GetNWInt("FATIG_AMOUNT") - 0.06, 0, 100))
					if self:GetNWInt("FATIG_TIRED") == 1 then
						self.OverRideSprint = false
					end
				end
			else
				self.Speed = self.Speed + self.Acceleration
			end
		end
		
			if self:Crouching() then
				self.CurMaxSpeed = self.CrawlSpeed
				self.Speed = self.MinSpeed
			end
		
		if (!self:KeyDown(IN_FORWARD) and !self:KeyDown(IN_MOVELEFT) and !self:KeyDown(IN_MOVERIGHT) and !self:KeyDown(IN_BACK)) then
			self.Speed = self.Speed / 1.05
		end
		
		if self.Speed > self.CurMaxSpeed then
			self.Speed = self.Speed + (self.CurMaxSpeed - self.Speed)
		end
		
		if self.Speed < self.MinSpeed then
			self.Speed = self.MinSpeed
		end
		
		if not self:OnGround() then
			self.Speed = self.MinSpeed
			self.CurMaxSpeed = self.MinSpeed
		end
		
		if (self:KeyDown(IN_FORWARD) or self:KeyDown(IN_MOVERIGHT) or self:KeyDown(IN_MOVELEFT) or self:KeyDown(IN_BACK)) and self:GetVelocity():Length() <= (self.MinSpeed - 10) then -- If we are moving, and if we bump into something
			self.Speed = self.WalkSpeed -- Slow us down
			self.CurMaxSpeed = self.WalkSpeed
		end
		
		if self:KeyDown(IN_WALK) then
			self.Speed = self.WalkSpeed
			self.CurMaxSpeed = self.WalkSpeed
		end
		
		if self:GetActiveWeapon():IsValid() then
			if self:GetActiveWeapon():GetClass() == "climb_swep" then
				if self:GetNWInt("FATIG_TIRED") == 1 then
					self.CurMaxSpeed = self.MaxSpeed / 2
					if self.Speed > self.CurMaxSpeed then
						self.Speed = self.CurMaxSpeed
					end
				end
			end
		end
		
		return self.Speed
	end
end

local function CSWEP_GraduallyAccelMe(ply, move)
	if ply:Alive() then
		if GetConVarNumber("cswep_gradualaccel") >= 1 then
			if GetConVarNumber("cswep_gradualaccel_global") >= 1 then
				if ply:OnGround() then
					GAMEMODE:SetPlayerSpeed(ply, ply:GetSpeed(), ply:GetSpeed())
				elseif ply:WaterLevel() > 2 then
					GAMEMODE:SetPlayerSpeed(ply, ply.SwimSpeed, ply.SwimSpeed)
				end
			else
				if ply:GetActiveWeapon():IsValid() then
					if ply:GetActiveWeapon():GetClass() == "climb_swep" or ply:GetActiveWeapon():GetClass() == "climb_swepnogrip" or ply:GetActiveWeapon():GetClass() == "climb_swep_anim" then
						if ply:OnGround() then
							GAMEMODE:SetPlayerSpeed(ply, ply:GetSpeed(), ply:GetSpeed())
						elseif ply:WaterLevel() > 2 then
							GAMEMODE:SetPlayerSpeed(ply, ply.SwimSpeed, ply.SwimSpeed)
						end
					else
						if ply:GetNWInt("FATIG_TIRED") == 0 then
							GAMEMODE:SetPlayerSpeed(ply, 250, 500)
						end
					end
				end
			end
		else
			GAMEMODE:SetPlayerSpeed(ply, 250, 500)
		end
	end
end
	

hook.Add("SetupMove", "CSWEP_GraduallyAccelMe", CSWEP_GraduallyAccelMe)