SWEP.Author = "Meoowe/GParkour creators"
SWEP.Contact = ""
SWEP.Purpose = ""
SWEP.Instructions = "Please refer to the readme for instructions on how to climb/for combinations.\nOr type cswep_helpmenu into your console."

SWEP.Spawnable = true
SWEP.AdminSpawnable = true

SWEP.ViewModel = ""
SWEP.WorldModel = ""
SWEP.HoldType = "normal"
SWEP.Category = "Movement (Spy)"

SWEP.Primary.ClipSize = -1
SWEP.Primary.DefaultClip = -1
SWEP.Primary.Automatic = true
SWEP.Primary.Ammo = "none"

SWEP.Secondary.ClipSize = -1
SWEP.Secondary.DefaultClip = -1
SWEP.Secondary.Automatic = true
SWEP.Secondary.Ammo = "none"

SWEP.HeartBeatDelay = CurTime()
SWEP.OverRideRegen = false
SWEP.SetAndForget = false

function SWEP:DrawWorldModel()
	return false
end

function SWEP:Initialize()
	self:SetWeaponHoldType(self.HoldType)
	self.Weapon:DrawShadow(false)
	self.Owner.Delay = 0.25
	self.Owner.UsedTimes = 0
	self.Owner.Hanging = false
	self.Owner.NeckBreakDelay = 0
	self.Owner.InitialPower = 240
	self.Owner.VelocityMinus = 15
	self.Owner.HasWallJumped = false
	self.Owner.HasReleased = false
	self.Owner.ExhaustedSoundDelay = CurTime()
	self.Owner.StamTimer = 0
	self.Owner.StamRegen = CurTime()

	self.ClimbSoundElse = {
	Sound("physics/body/body_medium_impact_soft1.wav"),
	Sound("physics/body/body_medium_impact_soft2.wav"),
	Sound("physics/body/body_medium_impact_soft3.wav"),
	Sound("physics/body/body_medium_impact_soft4.wav") }
	
	self.ClimbSoundGlass = {
	Sound("physics/glass/glass_sheet_step1.wav"),
	Sound("physics/glass/glass_sheet_step1.wav"),
	Sound("physics/glass/glass_sheet_step1.wav"),
	Sound("physics/glass/glass_sheet_step1.wav") }
	
	self.ClimbSoundMetal = {
	Sound("physics/metal/metal_box_impact_soft1.wav"),
	Sound("physics/metal/metal_box_impact_soft2.wav"),
	Sound("physics/metal/metal_box_impact_soft3.wav") }
	
	self.ClimbSoundVent = {
	Sound("physics/metal/metal_box_footstep1.wav"),
	Sound("physics/metal/metal_box_footstep2.wav"),
	Sound("physics/metal/metal_box_footstep3.wav"),
	Sound("physics/metal/metal_box_footstep4.wav") }
	
	self.ClimbSoundGrate = {
	Sound("physics/metal/metal_chainlink_impact_soft1.wav"),
	Sound("physics/metal/metal_chainlink_impact_soft2.wav"),
	Sound("physics/metal/metal_chainlink_impact_soft3.wav") }
	
	self.ClimbSoundPlastic = {
	Sound("physics/plastic/plastic_box_impact_soft1.wav"),
	Sound("physics/plastic/plastic_box_impact_soft2.wav"),
	Sound("physics/plastic/plastic_box_impact_soft3.wav"),
	Sound("physics/plastic/plastic_box_impact_soft4.wav") }
	
	self.ClimbSoundWood = {
	Sound("physics/wood/wood_box_impact_soft1.wav"),
	Sound("physics/wood/wood_box_impact_soft2.wav"),
	Sound("physics/wood/wood_box_impact_soft3.wav") }
	
	self.ClimbSoundConcrete = {
	Sound("player/footsteps/concrete1.wav"),
	Sound("player/footsteps/concrete2.wav"),
	Sound("player/footsteps/concrete3.wav"),
	Sound("player/footsteps/concrete4.wav") }
	
	self.ClimbSoundTile = {
	Sound("physics/plaster/ceiling_tile_step1.wav"),
	Sound("physics/plaster/ceiling_tile_step2.wav"),
	Sound("physics/plaster/ceiling_tile_step3.wav"),
	Sound("physics/plaster/ceiling_tile_step4.wav") }
	
	self.GrabSound = {
	Sound("physics/flesh/flesh_impact_hard3.wav"),
	Sound("physics/flesh/flesh_impact_hard4.wav"),
	Sound("physics/flesh/flesh_impact_hard6.wav") }
	
	self.BreakNeck = {
	Sound("physics/body/body_medium_break3.wav"),
	Sound("physics/body/body_medium_break4.wav") }
	
	self.SwingSound = {
	Sound("npc/fast_zombie/claw_miss1.wav"),
	Sound("npc/fast_zombie/claw_miss2.wav") }
	
	self.HitMan = {
	Sound("npc/vort/foot_hit.wav"),
	Sound("npc/zombie/zombie_hit.wav") }
	
	self.PushProp = {
	Sound("physics/flesh/flesh_impact_hard1.wav"),
	Sound("physics/flesh/flesh_impact_hard2.wav"),
	Sound("physics/flesh/flesh_impact_hard3.wav"),
	Sound("physics/flesh/flesh_impact_hard4.wav"),
	Sound("physics/flesh/flesh_impact_hard5.wav"),
	Sound("physics/flesh/flesh_impact_hard6.wav") }
	
	self.AllowedSnaps = {
	"npc_metropolice",
	"npc_combine_s",
	"npc_sniper",
	"npc_stalker",
	"npc_mossman",
	"npc_citizen",
	"npc_alyx",
	"npc_eli",
	"npc_gman",
	"npc_barney",
	"npc_kleiner",
	"npc_breen",
	"npc_zombie",
	"npc_zombie_torso",
	"npc_fastzombie",
	"npc_fastzombie_torso",
	"npc_monk" }
	
	self.Owner:SetNWInt("FATIG_AMOUNT", 100)
	self.Owner:SetNWInt("FATIG_TIRED", 0)
	
end

function SWEP:Reload()
end

function SWEP:Deploy()
	timer.Simple(1.0, function()
		if self.Owner == nil then return false end
		if SERVER then
			self.Owner:DrawViewModel(false)
		end
	end)
	
	-- Just in case
	self.Owner.Delay = 0.25
	self.Owner.UsedTimes = 0
	self.Owner.Hanging = false
	self.Owner.NeckBreakDelay = 0
	self.Owner.InitialPower = 240
	self.Owner.VelocityMinus = 15
	self.Owner.HasWallJumped = false
	self.Owner.HasReleased = false
	self.Owner.ExhaustedSoundDelay = CurTime()
	self.Owner.StamTimer = 0
	self.Owner.StamRegen = CurTime()
	
	if SERVER then
		if self.Owner:HasWeapon("climb_swepz") then
			self.Owner:StripWeapon("climb_swepz")
		end
		
		if self.Owner:HasWeapon("climb_swepzgrip") then
			self.Owner:StripWeapon("climb_swepzgrip")
		end
		
		self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT"))
		self.Owner:SetNWInt("FATIG_TIRED", self.Owner:GetNWInt("FATIG_TIRED"))
	end
	
	return true
end

function SWEP:Holster()
	self.Owner:SetMoveType(MOVETYPE_WALK)
	self.Owner.Hanging = false
	timer.Destroy("HideMyModel")
	timer.Destroy("0.3SecTimer")
	timer.Destroy("HasDoneARollTimer")
	return true
end

function SWEP:Think()
	//if CLIENT then return end
	
	-- I took the liberty to tab Zoey's untabbed code.
	if SERVER then
		if self.Owner:GetNWInt("FATIG_AMOUNT") > 0 and self.Owner:GetNWInt("FATIG_AMOUNT") <= 15 and self.Owner.Hanging == true then
			if SERVER then
				self.Owner:ViewPunch(Angle(math.random(-3.5 / self.Owner:GetNWInt("FATIG_AMOUNT"), 3.5 / self.Owner:GetNWInt("FATIG_AMOUNT")), math.random(-3 / self.Owner:GetNWInt("FATIG_AMOUNT"), 3 / self.Owner:GetNWInt("FATIG_AMOUNT")), math.random(-4 / self.Owner:GetNWInt("FATIG_AMOUNT"), 4 / self.Owner:GetNWInt("FATIG_AMOUNT"))))
			end
		end
		
		if self.Owner:GetNWInt("FATIG_TIRED") == 1 then
			if self.SetAndForget == false then
				self.Owner:SetMoveType(MOVETYPE_WALK)
				self.SetAndForget = true
			end
		end
		
			if GetConVarNumber("cswep_gradualaccel") == 0 then
				if self.Owner:GetNWInt("FATIG_AMOUNT") <= 25 then
					self.Owner.StamTimer = 0.2
				elseif self.Owner.Hanging == true or self.Owner:GetMoveType() == MOVETYPE_NONE then
					self.Owner.StamTimer = 0.1
				elseif self.Owner:KeyDown(IN_SPEED) then
				
					if self.Owner:OnGround() then
						self.Owner.StamTimer = 0.5
					else
						self.Owner.StamTimer = 0.5
					end
					
				elseif self.Owner:WaterLevel() >= 2 then
					self.Owner.StamTimer = 0.3
				elseif self.Owner:GetNWInt("FATIG_TIRED") == 1 then
					self.Owner.StamRegen = CurTime() + 0.6
				else
					self.Owner.StamTimer = 0.15
				end
			else
				if self.Owner:GetNWInt("FATIG_AMOUNT") <= 25 then
				
					if self.Owner:OnGround() then
						if self.Owner:GetVelocity():Length() <= 130 then
							self.Owner.StamTimer = 0.25
						else
							self.Owner.StamTimer = (self:GetVelocity():Length() / 600)
						end
					end	
					
				elseif self.Owner.Hanging == true or self.Owner:GetMoveType() == MOVETYPE_NONE then
					self.Owner.StamTimer = 0.1
				elseif self.Owner:WaterLevel() >= 2 then
					self.Owner.StamTimer = 0.3
				else
				
					if self.Owner:OnGround() then
						if self.Owner:GetVelocity():Length() <= 130 then
							self.Owner.StamTimer = 0.15
						else
							self.Owner.StamTimer = (self:GetVelocity():Length() / 600)
						end
					end
				end
				
			end
		
		if self:GetNWInt("FATIG_TIRED") == 0 then
			if CurTime() >= self.Owner.StamRegen then
				self.Owner.StamRegen = CurTime() + self.Owner.StamTimer
				if self.Owner:GetMoveType() == MOVETYPE_NONE and self.Owner:GetNWInt("FATIG_AMOUNT") > 0 then
					self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - 0.05, 0, 100))
				elseif self.Owner:GetMoveType() == MOVETYPE_WALK and (self.Owner:OnGround() and self.Owner:GetNWInt("FATIG_AMOUNT") < 100) or (not self.Owner:OnGround() and self.Owner.Hanging == false and self.Owner.UsedTimes == 0)  then
					if (self.Owner.OverRideSprint == false and self.Owner:OnGround()) or self.Owner:GetNWInt("FATIG_TIRED") == 1 or self.Owner:GetVelocity():Length() <= 130 then
						self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") + 2, 0, 100))
					end
				end
			end
		end
		
		if self.Owner:GetNWInt("FATIG_AMOUNT") <= 0 and self.Owner:GetNWInt("FATIG_TIRED") == 0 then
			self.Owner:SetNWInt("FATIG_TIRED",1)
			self.Owner:SetNWInt("FATIG_AMOUNT",0)
			self.OverRideRegen = true
			if self.Owner.Hanging == true then
				self.Owner:EmitSound(table.Random(self.GrabSound), 75, math.random(108, 115))
			end
			self.Owner.StamRegen = CurTime() + self.Owner.StamTimer
		end
		
		if self.Owner:GetNWInt("FATIG_TIRED") == 1 and self.Owner:GetNWInt("FATIG_AMOUNT") >= 25 then
			self.Owner:SetNWInt("FATIG_TIRED",0)
			self.OverRideRegen = false
			self.SetAndForget = false
		end
		
	end
	
		if self.Owner:GetNWInt("FATIG_TIRED") == 1 then
			if CurTime() > self.Owner.ExhaustedSoundDelay then -- better safe than sorry
				if CLIENT then
					surface.PlaySound("climbswep/effects/exhausted.mp3")
				end
				self.Owner.ExhaustedSoundDelay = self.Owner.ExhaustedSoundDelay * 0 + (CurTime() + 7.5)
				//self.Owner.StamRegen = CurTime() + 0.847
				if CurTime() > self.Owner.StamRegen then
					self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") + 0.25, 0, 100))
				end
			end
		end
		
		if (self.Owner:GetNWInt("FATIG_TIRED") == 0 and self.Owner:GetNWInt("FATIG_AMOUNT") <= 30) then
			if CurTime() > self.HeartBeatDelay then
				if CLIENT then
					surface.PlaySound("climbswep/effects/heartbeat.wav")
				end
				self.HeartBeatDelay = self.HeartBeatDelay * 0 + (CurTime() + 0.675)
			end
		end
	
	if self.Owner.Hanging == true and not self.Owner:OnGround() and not self.Owner:KeyDown(IN_ATTACK) and not self.Owner:KeyDown(IN_ATTACK2) then -- Zoey's shimmy code, thanks again!
		if self.Owner:GetMoveType() == MOVETYPE_FLY or self.Owner:GetMoveType() == MOVETYPE_NONE then
			local tr = {}
			tr.start = self.Owner:GetShootPos()
			tr.endpos = self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 40 )
			tr.filter = self.Owner
			tr.mask = MASK_SHOT
			local traceSHI = util.TraceLine( tr )
			if not traceSHI.Hit then
				if SERVER then
					self.Owner:SetLocalVelocity(Vector(0,0,0))
					self.Owner:SetMoveType(MOVETYPE_NONE)
				end
			end
			
			if not self.Owner:KeyDown(IN_MOVELEFT) and not self.Owner:KeyDown(IN_MOVERIGHT) and not self.Owner:KeyDown(IN_FORWARD) then
				if SERVER then
					self.Owner:SetLocalVelocity(Vector(0,0,0))
					self.Owner:SetMoveType(MOVETYPE_NONE)
				end
			end
			
			if self.Owner:KeyDown(IN_MOVELEFT) and traceSHI.Hit then
				if self.Owner:KeyDown(IN_JUMP) or self.Owner:KeyDown(IN_BACK) or self.Owner:KeyDown(IN_MOVERIGHT) or self.Owner:KeyDown(IN_FORWARD) then
					self.Owner:SetLocalVelocity(Vector(0,0,0))
					self.Owner:SetMoveType(MOVETYPE_NONE)
				else
					if SERVER then
						self.Owner:SetMoveType(MOVETYPE_FLY)
						//self.Owner:SetLocalVelocity(self.Owner:GetRight()*-20)
					end
					if self.Owner:KeyDown(IN_SPEED) then
						self.Owner:SetLocalVelocity(self.Owner:GetRight() * -40)
						self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT") - 0.08)
					else
						self.Owner:SetLocalVelocity(self.Owner:GetRight() * -20)
						self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT") - 0.04)
					end
				end
			end
			
			if self.Owner:KeyDown(IN_MOVERIGHT) and traceSHI.Hit then
				if self.Owner:KeyDown(IN_JUMP) or self.Owner:KeyDown(IN_BACK) or self.Owner:KeyDown(IN_MOVELEFT) or self.Owner:KeyDown(IN_FORWARD) then
					self.Owner:SetLocalVelocity(Vector(0,0,0))
					self.Owner:SetMoveType(MOVETYPE_NONE)
				else
					if SERVER then
						self.Owner:SetMoveType(MOVETYPE_FLY)
					end
					if self.Owner:KeyDown(IN_SPEED) then
						self.Owner:SetLocalVelocity(self.Owner:GetRight()*40)
						self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT") - 0.08)
					else
						self.Owner:SetLocalVelocity(self.Owner:GetRight()*20)
						self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT") - 0.04)
					end
				end
			end
			
			if self.Owner:KeyDown(IN_FORWARD) and traceSHI.Hit then
				if self.Owner:KeyDown(IN_JUMP) or self.Owner:KeyDown(IN_BACK) or self.Owner:KeyDown(IN_MOVERIGHT) or self.Owner:KeyDown(IN_MOVELEFT) then
					self.Owner:SetLocalVelocity(Vector(0,0,0))
					self.Owner:SetMoveType(MOVETYPE_NONE)
				else
					if SERVER then
						self.Owner:SetMoveType(MOVETYPE_FLY)
					end
					if self.Owner:KeyDown(IN_SPEED) then
						self.Owner:SetLocalVelocity(self.Owner:GetForward()*40)
						self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT") - 0.04)
					else
						self.Owner:SetLocalVelocity(self.Owner:GetForward()*20)
						self.Owner:SetNWInt("FATIG_AMOUNT", self.Owner:GetNWInt("FATIG_AMOUNT") - 0.08)
					end
				end
			end
		end
	end

	if self.Owner:KeyPressed(IN_JUMP) then
		if self.Owner:GetNWInt("FATIG_TIRED") == 1 then
			return false
		end
		
		if not self.Owner:OnGround() then
			if self.Owner.Hanging == false and not self.Weapon:CanGrab() then
				if self.Owner.UsedTimes >= 2 then
					local trace = self.Owner:GetEyeTrace()
					if trace.HitPos:Distance(self.Owner:GetShootPos()) <= 50 then -- Wall-jump using W/A/D
						if self.Owner.HasWallJumped == false then
							if self.Owner:KeyDown(IN_FORWARD) then
								self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - math.random(6,9), 0, 100))
								if SERVER then
									self.Owner:SetEyeAngles(self.Owner:EyeAngles() - Vector(0, 180, 0))
									self.Owner:SetLocalVelocity(self.Owner:GetForward() * -375 + Vector(0, 0, 75))
								end
								self.Degree = 180
								self.CameraType = 1 
								self.Owner:ViewPunch(Angle(-10, 0, 0))
								
							elseif self.Owner:KeyDown(IN_MOVERIGHT) then
								self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - math.random(9, 12), 0, 100))
								if SERVER then
									self.Owner:SetEyeAngles(self.Owner:EyeAngles() - Vector(0, 90, 0))
									self.Owner:SetLocalVelocity(self.Owner:GetRight() * 375 + Vector(0, 0, 75))
								end
								self.Degree = 90
								self.CameraType = 2
								self.Owner:ViewPunch(Angle(-10, 0, 0))
								
							elseif self.Owner:KeyDown(IN_MOVELEFT) then
								self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - math.random(9, 12), 0, 100))
								if SERVER then
									self.Owner:SetEyeAngles(self.Owner:EyeAngles() + Vector(0, 90, 0))
									self.Owner:SetLocalVelocity(self.Owner:GetRight() * -375 + Vector(0, 0, 75))
								end
								self.Degree = 90
								self.CameraType = 1
								self.Owner:ViewPunch(Angle(-10, 0, 0))
							end
							self.Owner.UsedTimes = 3
							self.Owner.HasWallJumped = true
						end
					end
				end
			elseif self.Owner.Hanging == true then
				if self.Owner:KeyDown(IN_FORWARD) then
					self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - math.random(12, 15), 0, 100))
					if SERVER then
						self.Owner:SetMoveType(MOVETYPE_WALK)
					end
					
					if SERVER then
						if self.Owner:EyeAngles().p <= -30 then
							self.Owner:SetEyeAngles(Angle(math.max(-30, self.Owner:EyeAngles().p), 0, 0) + Angle(0, self.Owner:EyeAngles().y, self.Owner:EyeAngles().r))
							timer.Simple(0.001, function()
								if self.Owner == nil then return false end
								self.Owner:SetLocalVelocity(self.Owner:GetForward() * 375 + Vector(0, 0, 190))
							end)
						else
							if SERVER then
								self.Owner:SetLocalVelocity(self.Owner:GetForward() * 375 + Vector(0, 0, 75))
							end
						end
					end
					self.Owner:ViewPunch(Angle(-5, 0, 0))
					self.Owner.Hanging = false
					self.Owner.UsedTimes = 3
				end
			end
		end
	end
	
	if self.Owner.HasReleased == false and not self.Owner:KeyDown(IN_ATTACK2) then
		self.Owner.HasReleased = true
	end
	
	if self.Owner:GetNWInt("FATIG_AMOUNT") <= 0 then
		self.Owner:SetNWInt("FATIG_AMOUNT", 0)
	elseif self.Owner:GetNWInt("FATIG_AMOUNT") >= 100 then
		self.Owner:SetNWInt("FATIG_AMOUNT", 100)
	end
	
end


function SWEP:PrimaryAttack()
	if CLIENT then return end
	local ActualSound
	
	if self.Owner:GetNWInt("FATIG_TIRED") == 1 then
		return false
	end
	
	if not self.Owner:OnGround() then
		if self.Owner:GetVelocity().z >= -750 then
			local pos = self.Owner:GetShootPos()
			local ang = self.Owner:GetAimVector()
			local tracedata = {}
			tracedata.start = pos
			tracedata.endpos = pos+(ang*45)
			tracedata.filter = self.Owner
			local trace = util.TraceLine(tracedata)
			
			if trace.MatType == MAT_CONCRETE then
				ActualSound = self.ClimbSoundConcrete
			elseif trace.MatType == MAT_METAL then
				ActualSound = self.ClimbSoundMetal
			elseif trace.MatType == MAT_VENT then
				ActualSound = self.ClimbSoundVent
			elseif trace.MatType == MAT_GRATE then
				ActualSound = self.ClimbSoundGrate
			elseif trace.MatType == MAT_WOOD then
				ActualSound = self.ClimbSoundWood
			elseif trace.MatType == MAT_TILE then
				ActualSound = self.ClimbSoundTile
			elseif trace.MatType == MAT_PLASTIC or trace.MatType == MAT_COMPUTER then
				ActualSound = self.ClimbSoundPlastic
			elseif trace.MatType == MAT_GLASS then
				ActualSound = self.ClimbSoundGlass
			else
				ActualSound = self.ClimbSoundElse
			end
			if self.Owner.Hanging == false or not self.Owner:GetMoveType() == MOVETYPE_NONE then
				if self.Owner.UsedTimes < 3 then
					if ( trace.HitWorld or trace.Entity:IsValid() and not trace.Entity:IsPlayer() and not trace.Entity:IsNPC() ) then
						local Vel = self.Owner:GetVelocity()
						if SERVER then
							self.Owner:SetVelocity(Vector(0, 0, self.Owner.InitialPower - (self.Owner.UsedTimes * self.Owner.VelocityMinus) - Vel.z))
						end
						self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - math.random(3,4), 0, 100))
						self.Owner:EmitSound(table.Random(ActualSound), 75, math.random(95, 105))
						self.Weapon:SetNextPrimaryFire( CurTime() + self.Owner.Delay )
						self.Owner.NeckBreakDelay = CurTime() + 1.5
						self.Owner.UsedTimes = self.Owner.UsedTimes + 1
						self.Owner.Speed = self.Owner.WalkSpeed
						self.Owner.CurMaxSpeed = self.Owner.CurMaxSpeed
						self.Weapon:ShakeEffect()
					end
				end
			else
			local Vel = self.Owner:GetVelocity()
				if SERVER then
					self.Owner:SetMoveType(MOVETYPE_WALK)
					self.Owner:SetLocalVelocity(Vector(0, 0, 250))
				end
				self.Owner:SetNWInt("FATIG_AMOUNT", math.Clamp(self.Owner:GetNWInt("FATIG_AMOUNT") - math.random(3,4), 0, 100))
				self.Owner:EmitSound(table.Random(ActualSound), 75, math.random(95, 105))
				self.Owner:EmitSound("player/suit_sprint.wav", 85, math.random(95, 105))
				timer.Simple(0.3, function() 
					if self.Owner == nil then return false end
					self.Owner.Hanging = false
				end)
				self.Weapon:SetNextPrimaryFire( CurTime() + (self.Owner.Delay + 0.15) )
				self.Owner.NeckBreakDelay = CurTime() + 1.5
				self.Owner:ViewPunch(Angle(-7, 0, 0))
			end	
		end
	else
	
		local trace = self.Owner:GetEyeTrace()
		if trace.HitPos:Distance(self.Owner:GetShootPos()) <= 60 then
			if CurTime() >= self.Owner.NeckBreakDelay then
				local phys = trace.Entity:GetPhysicsObject()
				self.Owner:LagCompensation(true)
				if trace.Entity:IsPlayer() or trace.Entity:IsNPC() then
					if GetConVarNumber("cswep_snapsallowed") == 1 then
						if trace.Entity:GetAimVector():DotProduct(self.Owner:GetAimVector()) > 0.6 then
								if SERVER then
									if trace.Entity:IsPlayer() then
										if GetConVarNumber("sbox_plpldamage") == 0 then
											trace.Entity:Kill()
											self.Owner:AddFrags(2)
											self.Owner:EmitSound(table.Random(self.BreakNeck), 80, math.random(95, 105))
										end
									elseif trace.Entity:IsNPC() and table.HasValue(self.AllowedSnaps, trace.Entity:GetClass()) then
										trace.Entity:TakeDamage(trace.Entity:Health(), self.Owner, self)
										self.Owner:AddFrags(2)
										self.Owner:EmitSound(table.Random(self.BreakNeck), 80, math.random(95, 105))
									end
								end
						else
							if SERVER then
								if not trace.Entity:IsNPC() then
									trace.Entity:ViewPunch(Angle(-25, 20, 0))
								end
								
								if trace.Entity:IsNPC() then
									trace.Entity:TakeDamage(math.random(5, 10), self.Owner, self)
								end
								self.Owner:ViewPunch(Angle(-4, 5, 0))
							end
							self.Owner:EmitSound(table.Random(self.HitMan), 80, math.random(95, 105))
						end
						
					else
						if SERVER then
							if not trace.Entity:IsNPC() then
								trace.Entity:ViewPunch(Angle(-25, 20, 0))
							end
							
							if trace.Entity:IsNPC() then
								trace.Entity:TakeDamage(math.random(5, 10), self.Owner, self)
							end
							self.Owner:ViewPunch(Angle(-4, 5, 0))
						end
						self.Owner:EmitSound(table.Random(self.HitMan), 80, math.random(95, 105))
					end
					
				elseif trace.Entity:GetClass() == "prop_physics" and trace.Entity:GetPhysicsObject():IsMoveable() == true then
					phys:ApplyForceOffset(self.Owner:GetAimVector():GetNormalized() * math.random(5000, 7000), trace.HitPos)
					self.Owner:EmitSound(table.Random(self.PushProp), 80, math.random(95, 105))
					self.Owner:ViewPunch(Angle(-4, 5, 0))
					
				elseif trace.Entity:GetClass() == "prop_ragdoll" then
					phys:ApplyForceOffset(self.Owner:GetAimVector():GetNormalized() * math.random(30000, 35000), trace.HitPos)
					self.Owner:EmitSound(table.Random(self.HitMan), 80, math.random(95, 105))
					self.Owner:ViewPunch(Angle(-4, 5, 0))
				end
			end
		else
			self.Owner:EmitSound(table.Random(self.SwingSound), 60, math.random(95, 105))
		end
		self.Owner.NeckBreakDelay = CurTime() + 0.7
		self.Owner:LagCompensation(false)
		self.Weapon:SetNextPrimaryFire( CurTime() + 0.7 )
	end
end

function SWEP:ShakeEffect()
	if self.Owner.UsedTimes == 1 then
		self.Owner:ViewPunch(Angle(0, 5, 0))
	elseif self.Owner.UsedTimes == 2 then
		self.Owner:ViewPunch(Angle(0, -5, 0))
	elseif self.Owner.UsedTimes == 3 then
		self.Owner:ViewPunch(Angle(-5, 0, 0))
	end
end

// SecondaryAttack

function SWEP:CanGrab() -- this part is not by me, it's by guys who made GParkour
	if self.Owner:GetNWInt("FATIG_TIRED") == 1 then 
		return false
	end
	
	local trace = {}
	trace.start = self.Owner:GetShootPos() + Vector( 0, 0, 15 )
	trace.endpos = trace.start + (self.Owner:GetAimVector():Angle():Forward( ) * 30)
	trace.filter = self.Owner

	local trHi = util.TraceLine(trace)
	
	local trace = {}
	trace.start = self.Owner:GetShootPos()
	trace.endpos = trace.start + (self.Owner:GetAimVector():Angle():Forward( ) * 30)
	trace.filter = self.Owner

	local trLo = util.TraceLine(trace)
	
	if trLo and trHi and trLo.Hit and not trHi.Hit then
		return true
	else 
		return false
	end
end -- And everything below is by me

function SWEP:SecondaryAttack()
	if CLIENT then return end
	if self.Owner.HasReleased == false then 
		return -- We don't want to let go of the ledge if we were accidently holding the secondary attack button while we were hanging on it, right?
	end
	
	local trace = self.Owner:GetEyeTrace()
	if not self.Owner:OnGround() then
		if self.Owner:GetVelocity():Length() <= 900 then
			if self.Owner.Hanging == false and self.Weapon:CanGrab() and not trace.Entity:IsNPC() and trace.Entity:GetPhysicsObject():IsMoveable() == false then
				if self.Owner:GetVelocity().z < 0 then
					self.Owner:ViewPunch(Angle(10, 0, 0))
				else
					self.Owner:ViewPunch(Angle(-5, 0, 0))
				end
				self.Owner.Hanging = true
				self.Owner.HasWallJumped = true
				self.Owner.HasReleased = false -- We don't want to let go of the ledge if we were accidently holding the secondary attack button while we were hanging on it, right?
				self.Owner:EmitSound(table.Random(self.GrabSound), 75, math.random(95, 105))
				self.Weapon:SetNextSecondaryFire(CurTime() + 0.35)
				self.Weapon:SetNextPrimaryFire(CurTime() + 0.5)
				if SERVER then
					self.Owner:SetMoveType(MOVETYPE_NONE)
					self.Owner:SetLocalVelocity(Vector(0, 0, 0))
				end
			elseif self.Owner.Hanging == true then
				local Vel = self.Owner:GetVelocity()
				if SERVER then
					self.Owner:SetMoveType(MOVETYPE_WALK)
					self.Owner:SetLocalVelocity(Vector(0, 0, 0))
				end
				self.Owner.Hanging = false
				self.Owner.UsedTimes = 3
				self.Weapon:SetNextSecondaryFire(CurTime() + 0.35)
				self.Weapon:SetNextPrimaryFire(CurTime() + 0.5)
			end	
		end
	end
end 

function SWEP:DrawHUD() -- Zoey's HUD code, thanks for the permission!
		local xpos	= ScrW() / 2 - ( 102 * ( ScrH() / 480.0 ) / 2 )
		local ypos	= 462 * ( ScrH() / 480.0 )
		local wide	= 102 * ( ScrH() / 480.0 )
		local tall	= 10  * ( ScrH() / 480.0 )
		local FATIG_TEXT = "Stamina (" .. math.Round(LocalPlayer():GetNWInt("FATIG_AMOUNT")) .. "%)"

			draw.RoundedBox( 4,
							 xpos,
							 ypos,
							 wide,
							 tall,
							 Color( 255, 255, 255, 200 ) )

			draw.RoundedBox( 2,
							 xpos + 1,
							 ypos + 1,
							 wide - 2,
							 tall - 2,
							 Color( 50, 205, 255, 200 ) )

			local text_font		= "Default"
			surface.SetFont( text_font )
			
			Width, Height		= surface.GetTextSize( FATIG_TEXT )
			local text_xpos		= xpos + wide / 2
			local text_ypos		= ypos + tall / 2 - 1 - ( Height / 2 )

			if LocalPlayer():GetNWInt("FATIG_AMOUNT") >= 1 then
				draw.RoundedBox( 2,
								 xpos + 1,
								 ypos + 1,
								 ( wide - 2 ) * math.Clamp( LocalPlayer():GetNWInt("FATIG_AMOUNT"), 0, 100 ) / 100,
								 tall - 2,
								 Color((255 + (self.Owner:GetNWInt("FATIG_AMOUNT") * -2.55)) / 1, 0, 0, 170 ) ) -- Slightly edited it so it would gradually become red the lower it is
			end

				draw.DrawText( FATIG_TEXT,
							   text_font,
							   text_xpos,
							   text_ypos,
							   Color( 255, 255, 255, 255 ),
							   TEXT_ALIGN_CENTER )
end